import os
import sys
import struct
import btrievePython as btrv
import smbus
from time import sleep

sys.path.append("/usr/local/actianzen/lib")
sys.path.append("/usr/local/actianzen/bin")
sys.path.append("/usr/lib")

i2c = smbus.SMBus(1)
addr = 0x53

i2c.write_byte_data(addr,0x2c,0x0f)
i2c.write_byte_data(addr,0x31,0x00)
i2c.write_byte_data(addr,0x38,0x00)
i2c.write_byte_data(addr,0x2d,0x08)

sno = 0
args = sys.argv
print(args)
if 2 <= len(args):
     if args[1].isdigit():
          sno = int(args[1])
     else:
          print('Argument is not digit')
          exit()
else:
     print('Arguments are too short')
     exit()

btrieveFileName = "/usr/local/actianzen/data/VSENSOR/DATA1.MKD"
btrieveFileName = "/usr/local/zendemo/vsensor1/db/DATA1.MKD"
recordFormat = "<qqiiii"

try:  
     # セッションの作成:
     btrieveClient = btrv.BtrieveClient(0x4232, 0) 

     # ファイルオブジェクトを割り当て:
     btrieveFile = btrv.BtrieveFile()
     # Open the file:
     rc = btrieveClient.FileOpen(btrieveFile, btrieveFileName, None, btrv.Btrieve.OPEN_MODE_NORMAL)
     if (rc == btrv.Btrieve.STATUS_CODE_NO_ERROR):
          print('ファイルを正常に開きました。\n')
     else:
          print('ファイルを開くのに失敗しました。ステータス: ', rc, '\n')

     while True:
          # X
          datax = i2c.read_i2c_block_data(addr, 0x32, 2)
          add_x = 256 * datax[0] + datax[1]   
          print(add_x) 

          # Y
          datay = i2c.read_i2c_block_data(addr, 0x34, 2)
          add_y = datay[0]+datay[1]
          print(add_y)

          # Z
          dataz = i2c.read_i2c_block_data(addr, 0x36, 2)
          add_z = dataz[0]+dataz[1]
          print(add_z)
          sleep(0.5)

          record = struct.pack(recordFormat,0,0,sno,add_x,add_y,add_z)
          rc = btrieveFile.RecordCreate(record)
          if (rc == btrv.Btrieve.STATUS_CODE_NO_ERROR):
               print(' レコードの挿入は正常に実行されました。')
          else:
               print(' レコードの挿入に失敗しました。ステータス: ', rc)
except:
     None
finally:
     # ファイルを Close:
     rc = btrieveClient.FileClose(btrieveFile)
     if (rc == btrv.Btrieve.STATUS_CODE_NO_ERROR):
          print('ファイルを正常に閉じました。')
     else:
          print('ファイルを閉じるのに失敗しました。エラー: ', rc)
