import React, { useState } from 'react';
import useInterval from 'use-interval';
import axios from 'axios';
import { useSelector } from "react-redux";
import RealtimeLineChart from 'components/RealtimeLineChart'

const TIME_RANGE_IN_MILLISECONDS = 500 * 1000;

export default function Dashboard() {

    const sensorList = useSelector((state)=> {
      return state.sensor.filter((i) => i[2] === true)
    })  


    const [postY, setPostsY] = useState(sensorList.map(name => ({
      name: name[0],
      data: []
    })));

     useInterval(() => {
      const arr=[]

      async function syncLoop() {
    
        // for文を使ってループ処理する
        for (let i = 0; i < postY.length; i++) {
          const hoge = await doSomething(postY[i].data,sensorList[i][0])
          arr.push({name:sensorList[i][1],data:hoge})
            console.log(sensorList[i][1])
            console.log('hogehogeho')
            console.log(i+1 + "番目の処理が完了！！" + "待ち時間は" +  "秒！！")
        }
        setPostsY(arr)

    }
    
    // 実行
    (async ()=>{
        console.log("同期的に呼び出す")
        await syncLoop()
    }).call()

    }, 5000); 
      
      const doSomething =   (data,id) => {
        return new Promise(async(resolve, reject)=>{
          try {       
              const sensor_data =  await axios.get(`http://172.31.8.30:8000/sno/${id}`).then((res) => {   
              console.log(res.data.length) 

              if (res.data.length == 0){
                return data
              }

              if (data.length !== 0){
                const last = data.slice(-1)[0];
                let dateObject = new Date(res.data[0].instime);         
                if (dateObject.getTime()  == last.x.getTime()){
                  return data
                }
              }

              let dateObject = new Date(res.data[0].instime); 
              return [
                  ...data,
                {
                  x:dateObject,
                  y:res.data[0].xdata
                }
                
              ]
            }
            )
            console.log(sensor_data)
            resolve(sensor_data);

            return sensor_data;
          } catch (err) {
            console.error(err.message);
          }
        })
      };

    return (
        <>
            <div className="bg-light-blue-500 px-3 md:px-8 h-2" />

            <div className="px-3 md:px-8 -mt-24">
                <div className="container mx-auto max-w-full">
                    <div className="grid grid-cols-1 xl:grid-cols-5">
                      <div>
                        </div> 
                        
                        <div className="xl:col-start-1 xl:col-end-4 px-4 mb-14 mt-20">
                        {
                          postY.length > 0 
                          ? <RealtimeLineChart
                              dataList={postY}
                              range={TIME_RANGE_IN_MILLISECONDS}
                             />
                           :<div className=" pt-10 m-10 text-5xl ">センサーを選択してください（Settings メニューから選択）</div>                             
                        }
                      </div>
                 
                        <div className="xl:col-start-1 xl:col-end-4 px-4 mb-14 mt-20">
                        {/* <RealtimeLineChart
                            dataList={[postY[1]]}
                            range={TIME_RANGE_IN_MILLISECONDS}
                        />  */}
                        </div> 
                    </div>
                </div>
            </div>

            <div className="px-3 md:px-8">
                <div className="container mx-auto max-w-full">
                    <div className="grid grid-cols-1 lg:grid-cols-2 xl:grid-cols-4 mb-4">
                    </div>
                </div>
            </div>

            <div className="px-3 md:px-8 h-auto">
                <div className="container mx-auto max-w-full">
                    <div className="grid grid-cols-1 xl:grid-cols-5">
                    </div>
                </div>
            </div>
        </>
    );
}
